package com.inca.npbusi.sales.bms_sa_con;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.CTable;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.control.Hovcallback;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMdeModel;
import com.inca.np.util.DecimalHelper;
import com.inca.pubsrv.stqtyhov.Dynstqty_hov;
import javax.swing.JOptionPane;

public class Sa_con_dtl_detail extends CDetailModel implements Hovcallback {
   public Sa_con_dtl_detail(CFrame var1, CMdeModel var2) {
      super(var1, "订单货品明细", var2);
   }

   public String getTablename() {
      return "bms_sa_con_goodsdtl_v";
   }

   public String getSaveCommandString() {
      return null;
   }

   protected String getOtherWheres() {
      return "nvl(execflag,0) <>1";
   }

   protected void invokeMultimdehov(int var1, String var2, String var3) {
      if (var2.equalsIgnoreCase("lotno")) {
         Dynstqty_hov var9 = new Dynstqty_hov();
         boolean var10 = false;
         boolean var11 = false;
         Sa_con_doc_ste var4;
         String var5 = (var4 = ((Sa_con_dtl_mde)this.mdemodel).condocste).getApvalue("库存选择到批号");
         String var6 = var4.getApvalue("库存选择到批次");
         String var7 = var4.getApvalue("库存选择到货位");
         String var8 = var4.getApvalue("库存选择到货品状态");
         boolean var13 = var4.getApvalue("库存是否选择到批号、批次、货位由销售控制").equals("1");
         if ("1".equals(var5)) {
            var10 = true;
         }

         "1".equals(var6);
         "1".equals(var7);
         if ("1".equals(var8)) {
            var11 = true;
         }

         var9.setGoodsdtlflag(true);
         var9.setLotflag(var10);
         var9.setBatchflag(true);
         var9.setPosflag(true);
         var9.setFlagEditable(var13);
         var9.setUsestatusflag(var11);
         var9.setHovcallback(this);
         var9.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
         int var12 = this.mdemodel.getMasterModel().getTable().getSelectedRow();
         this.mdemodel.getMasterModel().getItemValue(var12, "goodsdtlid");
         var2 = this.mdemodel.getMasterModel().getItemValue(var12, "goodsid");
         ((Sa_con_dtl_mde)this.mdemodel).getEntryid();
         var3 = ((Sa_con_dtl_mde)this.mdemodel).condocste.getItemValue(((Sa_con_dtl_mde)this.mdemodel).condocste.getRow(), "storageid");
         (new StringBuilder(" exists (select storageid from bms_st_def where  bms_st_def.storageid=bms_stqty_union_v.storageid ) and accflag <> 5 and bms_stqty_union_v.entryid =")).append(((Sa_con_dtl_mde)this.mdemodel).getEntryid()).toString();
         if ("".equals(var3)) {
            this.infoMessage("提示", "没有定义发货保管帐，请检查！");
            return;
         }

         var3 = " exists (select storageid from bms_st_set_dtl where stsetid = " + var3 + " and bms_st_set_dtl.storageid=bms_stqty_union_v.storageid ) and accflag <> 5 and bms_stqty_union_v.entryid =" + ((Sa_con_dtl_mde)this.mdemodel).getEntryid();
         String var14 = ((Sa_con_dtl_mde)this.mdemodel).condocste.getItemValue(((Sa_con_dtl_mde)this.mdemodel).condocste.getRow(), "customid");
         var3 = var3 + " and (  (nvl(limitid,0) = 0 and nvl(limitcustomsetid,0) = 0 ) or   limitid = " + var14 + "  or    limitcustomsetid in (select setid from pub_custom_set_dtl where customid = " + var14 + "))  and bms_stqty_union_v.goodsid=" + var2 + " and (bms_stqty_union_v.bannedCustomerID is null or bms_stqty_union_v.bannedCustomerID <> " + var14 + ")  and (bms_stqty_union_v.bannedCustomerSetID is null or " + var14 + " not in (select customid from pub_custom_set_dtl where setid = bms_stqty_union_v.bannedCustomerSetID))";
         ((Sa_con_dtl_mde)this.mdemodel).condocste.getDBtableModel();
         var9.showDialog(this.getParentFrame(), "选择货品", "settletypeid", "", var3);
      }

   }

   public int hovcallback_itemvaluechanged(int var1, String var2, String var3, DBTableModel var4) {
      if (!var2.equalsIgnoreCase("editgoodsqty") && !var2.equalsIgnoreCase("editpackqty")) {
         return 0;
      } else if ((var2 = var4.getItemValue(var1, "editgoodsqty")).length() == 0) {
         return 0;
      } else {
         var3 = var4.getItemValue(var1, "goodsqty");
         if (DecimalHelper.toDec(var2).compareTo(DecimalHelper.toDec(var3)) > 0) {
            this.warnMessage("提示", "数量不可大于可销库存");
            var4.setItemValue(var1, "editgoodsqty", "");
            var4.setItemValue(var1, "editpackqty", "");
            return 0;
         } else {
            var3 = var4.getItemValue(var1, "posid");
            String var5 = var4.getItemValue(var1, "packsize");
            RemotesqlHelper var6 = null;
            var3 = "select 1 from bms_storer_pos t where nvl(t.goodsunitflag,0) = 1 and posid = " + var3;
            var6 = new RemotesqlHelper();

            try {
               DBTableModel var11;
               if ((var11 = var6.doSelect(var3, 0, 1)) != null && var11.getRowCount() > 0) {
                  Double var8 = Double.valueOf(var2);
                  Double var10 = Double.valueOf(var5);
                  if (var8 % var10 != 0.0) {
                     this.infoMessage("提示", "整件货位输入的数量必须是包装的整数倍！");
                     var4.setItemValue(var1, "editgoodsqty", "");
                     var4.setItemValue(var1, "editpackqty", "");
                     return 0;
                  }
               }
            } catch (Exception var7) {
               var7.printStackTrace();
            }

            int var9 = this.getRow();
            this.setItemValue(var9, "goodsid", var4.getItemValue(var1, "goodsid"));
            this.setItemValue(var9, "goodsdtlid", var4.getItemValue(var1, "goodsdtlid"));
            this.setItemValue(var9, "dtlgoodsqty", var4.getItemValue(var1, "editgoodsqty"));
            this.setItemValue(var9, "batchno", var4.getItemValue(var1, "batchno"));
            this.setItemValue(var9, "batchid", var4.getItemValue(var1, "batchid"));
            this.setItemValue(var9, "lotno", var4.getItemValue(var1, "lotno"));
            this.setItemValue(var9, "lotid", var4.getItemValue(var1, "lotid"));
            this.setItemValue(var9, "posno", var4.getItemValue(var1, "posno"));
            this.setItemValue(var9, "posid", var4.getItemValue(var1, "posid"));
            this.setItemValue(var9, "storageid", var4.getItemValue(var1, "storageid"));
            this.setItemValue(var9, "storagename", var4.getItemValue(var1, "storagename"));
            this.setItemValue(var9, "goodsstatusid", var4.getItemValue(var1, "goodsstatusid"));
            this.on_itemvaluechange(var9, "goodsid", var4.getItemValue(var1, "goodsid"));
            this.tableChanged(var9);
            return 1;
         }
      }
   }

   public void hovcallback_cancel() {
   }

   public boolean hovcallback_checkresult(int var1, DBTableModel var2, CTable var3) {
      return true;
   }

   public void hovcallback_ok(int var1, DBTableModel var2, CTable var3) {
   }

   protected int on_new(int var1) {
      this.mdemodel.getMasterModel().setdbStatus(this.mdemodel.getMasterModel().getRow(), 2);
      return super.on_new(var1);
   }

   public void on_doubleclick(int var1, int var2) {
      this.mdemodel.getMasterModel().setdbStatus(this.mdemodel.getMasterModel().getRow(), 2);
      super.on_doubleclick(var1, var2);
   }

   public int on_beforesave() {
      String var1 = ClientUserManager.getCurrentUser().getEntryid();
      if (this.getRowCount() > 1) {
         String var2;
         String var3 = a(var2 = ((Sa_con_dtl_mde)this.mdemodel).condocste.getItemValue(((Sa_con_dtl_mde)this.mdemodel).condocste.getRow(), "customid"));

         for(int var4 = 0; var4 < this.getRowCount(); ++var4) {
            if (this.getdbStatus(var4) != 3) {
               String var5 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "goodsid");
               String var6 = this.getItemValue(var4, "lotid");
               String var7;
               if ((var7 = a(var1, var5)) != null && var7.trim().length() > 0 && !"0".equals(var7)) {
                  String var9;
                  int var11;
                  String var12;
                  if ("1".equals(var7)) {
                     for(var11 = var4 + 1; var11 < this.getRowCount(); ++var11) {
                        if (this.getdbStatus(var11) != 3) {
                           var12 = this.getItemValue(var11, "goodsid");
                           var9 = this.getItemValue(var11, "lotid");
                           if (var5.equals(var12) && !var6.equals(var9)) {
                              this.infoMessage("提示", "货品ID[" + var5 + "]不允许混批，只能为一个批号");
                              return -1;
                           }
                        }
                     }
                  } else if ("2".equals(var7) && (var3 == null || !"0".equals(var3.trim()))) {
                     if (var3 != null && "1".equals(var3.trim())) {
                        for(var11 = var4 + 1; var11 < this.getRowCount(); ++var11) {
                           if (this.getdbStatus(var11) != 3) {
                              var12 = this.getItemValue(var11, "goodsid");
                              var9 = this.getItemValue(var11, "lotid");
                              if (var5.equals(var12) && !var6.equals(var9) && JOptionPane.showConfirmDialog(this.frame, "客户ID[" + var2 + "]允许混批一个，货品ID[" + var5 + "]只能为一个批号,是否继续开单？", "提示", 0) == 1) {
                                 return -1;
                              }
                           }
                        }
                     } else if (var3 != null && "2".equals(var3.trim())) {
                        var11 = 1;

                        for(int var8 = 0; var8 < this.getRowCount(); ++var8) {
                           if (this.getdbStatus(var8) != 3) {
                              var9 = this.getItemValue(var8, "goodsid");
                              String var10 = this.getItemValue(var8, "lotid");
                              if (var5.equals(var9) && !var6.equals(var10)) {
                                 ++var11;
                              }
                           }
                        }

                        if (var11 > 2 && JOptionPane.showConfirmDialog(this.frame, "客户ID[" + var2 + "]允许混批两个，货品ID[" + var5 + "]不能为多于两个批号,是否继续开单？", "提示", 0) == 1) {
                           return -1;
                        }
                     }
                  }
               }
            }
         }
      }

      return super.on_beforesave();
   }

   private static String a(String var0) {
      String var1 = "";
      var0 = "select nomixsale from pub_company_to_definfo_v where companyid = " + var0 + " and entryid = " + ClientUserManager.getCurrentUser().getEntryid();
      RemotesqlHelper var2 = new RemotesqlHelper();

      try {
         DBTableModel var4;
         if ((var4 = var2.doSelect(var0, 0, 1)) != null && var4.getRowCount() > 0) {
            var1 = var4.getItemValue(0, "nomixsale");
         }
      } catch (Exception var3) {
         var3.printStackTrace();
      }

      return var1;
   }

   private static String a(String var0, String var1) {
      String var2 = null;
      String var3 = "select a.nomixsale from pub_entry_goods a where a.goodsid=%s and a.entryid=%s";
      RemotesqlHelper var4 = new RemotesqlHelper();

      try {
         DBTableModel var6;
         if ((var6 = var4.doSelect(String.format(var3, var1, var0), 0, 1)) != null && var6.getRowCount() > 0) {
            var2 = var6.getItemValue(0, "nomixsale");
         }
      } catch (Exception var5) {
         var5.printStackTrace();
      }

      return var2;
   }
}
